'                   Copyright (c) 2004 SQUARE ENIX CO.,LTD.
'                             All Rights Reserved.
'  
'  This file contains unpublished confidential  and proprietary information
'  of SQUARE ENIX CO.,LTD.  The contents of this file  may not be copied or
'  duplicated,  in whole or in part, by any means,  electronic or hardcopy,
'  without  the express  prior written permission  of  SQUARE ENIX CO.,LTD.
'  This copyright notice does not imply any actual or intended publication.
'  
'  $Id$
'  
'  Author: Atsushi Ebisawa (ebisawa@square-enix.co.jp)
'  
Option Explicit

function CopyUVs( byRef oPoly, copyCluster )

    ' Rs[̃f(copyClusterƓÕf)T
    dim oRoot, children
    set oRoot = Application.ActiveProject.ActiveScene.Root 
    set children = oRoot.FindChildren( copyCluster.name )
    if children.count <> 1 then
        ' Rs[悪Ȃ or Hꍇ
        exit function
    end if

'    logmessage "Cluster: " & copyCluster.name
    ' 
    dim dup
    set dup = Duplicate( oPoly, , siOriginalHistory, 1, 1, 0, 0, 1, 0, 1, , , , , , , , , , , 0 )
    dim oDup
    set oDup = dup(0)
    dim i
    dim cluster
    for each cluster in oDup.ActivePrimitive.Geometry.Clusters
'        logmessage "comp: " & cluster.name & "  " & copyCluster.name & " (" & cluster.type & ")"
        if cluster.type = "poly" and cluster.name <> copyCluster.name then
'            logmessage "delete cluster: " & cluster.name
            dim aElements
            aElements = cluster.Elements.Array
            if ubound(aElements) <> -1 then ' NX^̔z񂪋̂Ƃ͉Ȃ
'logmessage "size: " & ubound(aElements)
                SetSelFilter "Polygon"
                ' |S폜
                SelectMembers oDup.name & ".polymsh.cls." & cluster.name
                ApplyTopoOp "DeleteComponent", , siUnspecified, siPersistentOperation
                ' NX^폜
'                DeleteObj oDup.name & ".polymsh.cls." & cluster.name
            end if
        end if
    next
'    logmessage "end:"

    ' UVRs[
    SelectObj copyCluster.name
    AddToSelection oDup.name
    AEuvcopy145


    ' ΑRs[
    ' Α(LR)Mesh邩H
    dim mirrorMesh, found
    GetMirrorMesh copyCluster.name, mirrorMesh, found
    if found = False then
        ' ΏI
        exit function
    end if

    logmessage "found mirrorMesh: " & copyCluster.name & " -> " & mirrorMesh

    ' ܂]
    SelectObj oDup.name
    Scale , -1, 1, 1, siAbsolute, siPivot, siObj, siX, , , , , , , , 0
    ApplyTopoOp "InvertPolygon", , siUnspecified, siPersistentOperation
    ResetTransform , siCtr, siSRT, siXYZ
    FreezeObj

    ' UVRs[
    SelectObj mirrorMesh
    AddToSelection oDup.name
    AEuvcopy145

    DeleteObj oDup
end function


function GetMirrorMesh( byRef orgMesh, byRef mirrorMesh, byRef found )
    found = false

    dim aTmp
    aTmp = split( orgMesh, "_" )
    if ubound(aTmp) <> 1 then
        ' OA"xxx_xxx" ̌`ɂȂĂȂ
        exit function
    end if

    ' 1ڂLȂR֕ϊARȂL֕ϊ
    dim first, tmp2
    first = chr(ascb(aTmp(1)))
    if first = "L" then
        tmp2 = replace( aTmp(1), "L", "R", 1, 1, vbBinaryCompare )
    elseif  first = "R" then
        tmp2 = replace( aTmp(1), "R", "L", 1, 1, vbBinaryCompare )
    end if

    mirrorMesh = aTmp(0) & "_" & tmp2
    found = true
end function










'---------------
function XSILoadPlugin( in_reg )
	in_reg.Author = "nuenaka"
	in_reg.Name = "MultiCopyUVsPlugin"
	in_reg.Email = "nuenaka@square-enix.co.jp"
	in_reg.URL = "http://happy/document/XSI/index.html"
	in_reg.Major = 1
	in_reg.Minor = 0

	in_reg.RegisterCommand "MultiCopyUVs","MultiCopyUVs"
	'RegistrationInsertionPoint - do not remove this line

	XSILoadPlugin = true
end function

function XSIUnloadPlugin( in_reg )
	XSIUnloadPlugin = true
end function

function MultiCopyUVs_Init( ctxt )
	dim oCmd
	set oCmd = ctxt.Source
	oCmd.Description = ""
	oCmd.ReturnValue = true

	MultiCopyUVs_Init = true
end function

function MultiCopyUVs_Execute(  )


	dim tpc
	tpc = TechPluginCertification( "MultiCopyUVs", "1.1" )
	if tpc <> True then
		'
	else

dim coll
set coll = CreateObject( "XSI.Collection" )
coll.add( selection(0) )

dim oPoly
set oPoly = coll(0)
dim cls
for each cls in oPoly.ActivePrimitive.Geometry.Clusters
    if cls.type = "poly" and ubound(cls.Elements.Array) > 0 then
        CopyUVs oPoly, cls
    end if
next

	end if	'TPC

	MultiCopyUVs_Execute = true
end function

